import pandas as pd
import numpy as np
import re
import pickle
import os
import pandas as pd

def readFile(path,mlen=11110):
    buf = ''
    #print("opening file...")
    i = 0
    with open(path, 'r') as fp:
        try:
            while(True):
                buf = fp.read()
                break 
                if i > mlen and "Record" in tmp:
                    break
                buf += tmp
                i += 1

        except Exception as ex:
            pass
            #print(str(ex))
    #print("splitting data")
    buf=re.split("# Record", buf)
    #print("file split, compiling regex")

    r = re.compile(r'#\s\w+:\s(?P<name>(?:\w+ *)+)[.?\n\s]*(?P<value>((?:.*-?\d+\.\d+E?[+-]?\d*(\s|\n)+)+|(\d+\s*)*))', flags=re.MULTILINE)
    #print("regex compiled")
    data = []
    i = 0
    for item in buf:
        i = i + 1
        #print(item)
        tmp_dict = {}
        groups_iter = r.findall(item)
        if len(groups_iter) == 0:
            continue
        for groups in groups_iter:
            if groups is not None:
                if 'orders' in groups or 'dofs' in groups:
                    for i, val in enumerate(groups[1].split()):
                        #print(val)
                        tmp_dict[groups[0]+str(i)]=float(val)
                elif 'dofs' not in groups:
                    try:
                        tmp_dict[groups[0]]=float(groups[1].strip())
                    except Exception as ex:
                        pass
        data.append(tmp_dict)
    return data

#test below
if __name__=='__main__':
    alldata = []

    for file in os.listdir('data/'):
        if 'deep' not in file or 'short' not in file:
            #print('skipping', file)
            continue
        #print(file)
        data = readFile('data/'+file, 10e6)
        #print("Data reading done")
        data=pd.DataFrame.from_dict(data)
        #print(data.size, len(data.columns))
        data.fillna(0, inplace=True)
        alldata.append(data)
    data = pd.concat(alldata)
    #print("saving data")
    with open('parsed_data/' + file + '.parsed', 'wb+') as fp:
        pickle.dump(data, fp)

    n_map = dict(enumerate(data['nref'].astype('category').cat.categories))
    orders0_map = dict(enumerate(data['orders0'].astype('category').cat.categories))
    orders1_map = dict(enumerate(data['orders1'].astype('category').cat.categories))
    orders2_map = dict(enumerate(data['orders2'].astype('category').cat.categories))
    orders3_map = dict(enumerate(data['orders3'].astype('category').cat.categories))
    orders4_map = dict(enumerate(data['orders4'].astype('category').cat.categories))
    print(n_map, orders0_map, orders1_map, orders2_map, orders3_map, orders4_map)
    print(data['orders1'].unique())
    pickle.dump(n_map, open("nmap.pickle", 'wb'))
    pickle.dump(orders0_map, open("o0.pickle", 'wb'))
    pickle.dump(orders1_map, open("o1.pickle", 'wb'))
    pickle.dump(orders2_map, open("o2.pickle", 'wb'))
    pickle.dump(orders3_map, open("o3.pickle", 'wb'))
    pickle.dump(orders4_map, open("o4.pickle", 'wb'))