from parseData import readFile
import os
import sys
import pandas as pd
from keras.models import Model
from keras.models import load_model
from keras.optimizers import Adam
import pickle
import tensorflow as tf


import numpy as np
#import matplotlib.pyplot as plt
nnc = load_model("checkpoint-hpada-rs", custom_objects={
    'Adam': lambda learning_rate: Adam(lr=learning_rate)})

if __name__=='__main__':

    train_cols = ['x1', 'x2', 'y1', 'y2', 'h1', 'h2', 'rnorm', 'rnorm  max']
    alldata = []

    data = readFile(sys.argv[1], 10e6)
    #print("Data reading done")
    data=pd.DataFrame.from_dict(data)
    #print(data.size, len(data.columns))
    data.fillna(0, inplace=True)
    alldata.append(data)

    data = pd.concat(alldata)
    # print(data['nref'].astype('category').cat.categories)
    # n_map = dict(enumerate(data['nref'].astype('category').cat.categories))
    # orders0_map = dict(enumerate(data['orders0'].astype('category').cat.categories))
    # orders1_map = dict(enumerate(data['orders1'].astype('category').cat.categories))
    # orders2_map = dict(enumerate(data['orders2'].astype('category').cat.categories))
    # orders3_map = dict(enumerate(data['orders3'].astype('category').cat.categories))
    # orders4_map = dict(enumerate(data['orders4'].astype('category').cat.categories))

    # pickle.dump(n_map, open("nmap.pickle", 'wb'))
    #     # pickle.dump(orders0_map, open("o0.pickle", 'wb'))
    #     # pickle.dump(orders1_map, open("o1.pickle", 'wb'))
    #     # pickle.dump(orders2_map, open("o2.pickle", 'wb'))
    #     # pickle.dump(orders3_map, open("o3.pickle", 'wb'))
    #     # pickle.dump(orders4_map, open("o4.pickle", 'wb'))
    n_map = pickle.load(open("nmap.pickle", 'rb'))
    orders0_map = pickle.load(open("o0.pickle", 'rb'))
    orders1_map = pickle.load(open("o1.pickle", 'rb'))
    orders2_map = pickle.load(open("o2.pickle", 'rb'))
    orders3_map = pickle.load(open("o3.pickle", 'rb'))
    orders4_map = pickle.load(open("o4.pickle", 'rb'))
    print(n_map, orders0_map, orders1_map, orders2_map, orders3_map, orders4_map)




    for i in range(128):
        if 'dofs{}'.format(i) not in train_cols:
            train_cols.append('dofs{}'.format(i))
            data['dofs{}'.format(i)] = 0.
    target_cols = ['nref', 'orders0', 'orders1', 'orders2', 'orders3', 'orders4']

    #data['nref'] = data['nref'].astype('category').cat.codes
    #for i in range(5):
        #print('orders{}'.format(i), data['orders{}'.format(i)].nunique())
        #data['orders{}'.format(i)] = data['orders{}'.format(i)].astype('category').cat.codes
    train_data = data[train_cols]
    #target_data = data[target_cols]
    #target_data = [data[x].astype('category').cat.codes for x in target_cols]
    #print(target_data)


    #x=nnc.evaluate(train_data, target_data)
    x=train_data#.sample(5)
    res = [x_.argmax(axis=-1) for x_ in nnc.predict(x)]

    print(np.array(res))
    print(np.array(res).shape)
    file = open(sys.argv[2], "w")
    i = 1
    for items in zip(res[0], res[1], res[2], res[3], res[4], res[5]):
        file.write("\n # RECORD:\n\t" + str(int(i)) + "\n")
        i = i + 1
        file.write(' # OUTPUT: nref\n\t' + str(int(n_map[items[0]])) + '\n')
        file.write(' # OUTPUT: orders\n\t' +
              str(int(orders0_map[items[1]])) + "\t" +
              str(int(orders1_map[items[2]])) + "\t" +
              str(int(orders2_map[items[3]])) + "\t" +
              str(int(orders3_map[items[4]])) + "\t" +
              str(int(orders4_map[items[5]])) + '\n')
    file.close()




